#include "gba.h"

#define DEBUG

#define	RED		%C0
#define	GREEN	%C1
#define	YELLOW	%C2
#define	BLUE	%C3
#define	PURPLE	%C4
#define	WATER	%C5
#define	WHITE	%C6

#define	MODE_TITLE	0
#define	MODE_GAME	1
#define	MODE_SCORE	2

#define	GM_LOADING		0
#define	GM_START		1
#define	GM_GAME			2
#define	GM_CHANGING		3
#define	GM_CLEAR		4
#define	GM_ALL_CLEAR	5
#define	GM_MOVING		6

extern const u16 font_Palette[16];
extern const u8 font_Char[32*128/8*32/8 + 0];
void init_rand(u16 nSeed);
u16	rand();
u16 narnd(u16 max);

u16 cont,trg;                  // L[
u32 intr_buf[0x200];         // 荞݃C[`pobt@
u8  *bmp_buf;
u32 cnt;
u16 mode,old_mode;
u16	tilei[4][5];

s16 time;
u32 score;
u16 stage;
u16 gm_mode;
u16 gm_cnt;
u16 x1,y1,x2,y2;
u16 nx,ny,ox,oy;

const u16 tilen[20]={
	6*0+150*0,6*1+150*0,6*2+150*0,6*3+150*0,6*4+150*0,
	6*0+150*1,6*1+150*1,6*2+150*1,6*3+150*1,6*4+150*1,
	6*0+150*2,6*1+150*2,6*2+150*2,6*3+150*2,6*4+150*2,
	6*0+150*3,6*1+150*3,6*2+150*3,6*3+150*3,6*4+150*3,
};

struct bmp_head{
	u32	head_size;		//==40
	s32	w;
	s32	h;
	s16	plane;			//==1
	s16 pix;			//sNZ̃rbg
	s32	comp;			//==0 񈳏k
	u32	size;			//C[W̃TCY(byteP)
	u32	dx;				//w̉𑜓x
	u32 dy;				//x̉𑜓x
	u32 pal;			//pbg̐
	u32 zpal;			//dvȃpbg̐
};

typedef struct{
	u8	b,g,r,a;		// J[pbg`
} RGBQUAD;


void key_read(void);
s32 oprintf(s16 x,s16 y,s8 *fmt, ...);
void oprn_clear();

extern u8 __iwram_overlay_lma;

typedef void (*IntrFuncp)(void);
void dummy_intr(void);
void vsync_intr(void);

const IntrFuncp IntrTable[] = {
    vsync_intr,     // uuN荞
};

u16 pal_cnv(u16 b,u16 g,u16 r){
	r=r*115/100;
	if(r>255) r=255;
	g=g*115/100;
	if(g>255) g=255;
	b=b*115/100;
	if(b>255) b=255;
	return((r>>3)+((g<<2)&0x3e0)+((b<<7)&0x7c00));
}

s32 bmp2vram(u8 *buf){
	s32 fsize;
	s32 i,npal,x,y;
	u8  *pal;
	u16 *cg;
	u8  *img,c1,c2;
	struct bmp_head *bh;
	if((buf[0]!='B')||(buf[1]!='M')){
		return(0);
	}
	fsize=buf[2]+(buf[3]<<8)+(buf[4]<<16);
	bh=(void *)(buf+14);
	npal=buf[14+32]+(buf[14+32+1]<<8);
	if(bh->pix==8){
		if(npal==0) npal=256;
	}
	if((bh->w!=240)||(bh->h!=160)||(bh->pix!=8)){
		//PcPrintf("not support BMP.\n");
	}
	img=buf+(buf[10]+(buf[11]<<8)+(buf[12]<<16)+(buf[13]<<24));
	cg=(u16 *)(BG_VRAM+0x4000);
	for(y=0;y<160;y++){
		for(x=0;x<240;x+=2){
			c1=img[x+(159-y)*240];
			c2=img[x+(159-y)*240+1];
			cg[((x/8)+(y/8*30))*32+((x>>1)&3)+(y%8)*4]=c1+(c2<<8);
		}
	}
	pal=(void *)(buf+14+40);
	for(i=0;i<npal;i++){
		*((u16 *)0x5000000+i)=pal_cnv(pal[i*4+0],pal[i*4+1],pal[i*4+2]);
	}
	for(y=0;y<20;y++){
		for(x=0;x<30;x++){
			*((u16 *)BG_VRAM+x+y*32)=x+y*30;
		}
	}
	return(fsize);
}

dot_set(u16 x,u16 y,u16 c){
	u16 *add;
	add=(u16 *)(OBJ_MODE0_VRAM+32*128+(x/8)*32+(x&4)/2+(y/8)*32*8+(y%8)*4);
	*add=c;
}

mk_waku(){
	s32 i;
	for(i=0;i<40;i++){
		dot_set(0,0+i,0x00ff);
		dot_set(46,0+i,0xff00);
	}
	for(i=0;i<48;i+=4){
		dot_set(i,0,0xffff);
		dot_set(i,0+39,0xffff);
		dot_set(i,0+1,0xffff);
		dot_set(i,0+38,0xffff);
	}
}

disp_waku(s16 n,s16 x,s16 y){
	*((u16 *)0x7000000+4*(64+n))=(y & 0xff);
	*((u16 *)0x7000002+4*(64+n))=0xc000+(x & 0xff);
	*((u16 *)0x7000004+4*(64+n))=(n<<12)+0x80;
}

mk_bg(u32 no,u32 mode){
	u16 *add,ofs;
	u32 x,y;
	u32 x1,y1;
	add=(u16 *)(BG_VRAM+0x800*no);
	for(y=0;y<20;y++){
		*(add+y*32+30)=600;
		*(add+y*32+31)=600;
	}
    DmaClear(3, 600,   add+32*20,     32*2*12,            16);
	for(y=0;y<4;y++){
		for(x=0;x<5;x++){
			ofs=x*6+y*32*5;
			if(mode & (1<<(x+y*5))){	//GL
				for(y1=0;y1<5;y1++){
					for(x1=0;x1<6;x1++){
						*(add+ofs+x1+y1*32)=tilen[tilei[y][x]]+(x1)+(y1*30);
					}
				}
			}
			else{						//
				for(y1=0;y1<5;y1++){
					for(x1=0;x1<6;x1++){
						*(add+ofs+x1+y1*32)=600;
					}
				}
			}
		}
	}
}

disp_on(){
	*(vu16 *)REG_DISPCNT = DISP_OBJ_CHAR_1D_MAP | 
		DISP_MODE_0 | DISP_OBJ_ON | DISP_BG0_ON | DISP_BG1_ON | DISP_BG2_ON; // LCDC ON
}

disp_off(){
	*(vu16 *)REG_DISPCNT = 0;
}

init_title(){
	u32 i,j;
	disp_off();
	bmp_buf=&__iwram_overlay_lma;
	bmp_buf+=bmp2vram(bmp_buf);
	for(i=0;i<4;i++){
		for(j=0;j<5;j++){
			tilei[i][j]=j+i*5;
		}
	}
	mk_bg(1,0);
	mk_bg(2,0);
	disp_on();
}

mode_title(){
	if(cnt & 0x10){
		oprintf(75,80,"%C0PUSH START");
	}
	if(trg & START_BUTTON){
		mode=MODE_GAME;
	}
}

init_game(){
	time=score=0;
	stage=0;
	gm_mode=GM_LOADING;
	mk_waku();
}

gm_moving(){
	ox=x1;
	oy=y1;
	gm_mode=GM_MOVING;
}

mode_game(){
	u32 i,j,k;
	disp_waku(0,x1,y1);
	disp_waku(1,x2,y2);
	oprintf(0,4,"%C2SCORE=%d",score);
	oprintf(148,4,"%C5TIME=%d",time);
	switch(gm_mode){
	case GM_LOADING:
		disp_off();
		if((i=bmp2vram(bmp_buf))==0){
			gm_mode=GM_ALL_CLEAR;
			bmp_buf=&__iwram_overlay_lma;
			gm_cnt=180;
			return;
		}
		stage++;
		bmp_buf+=i;
		DmaClear(3,0xffff,tilei,sizeof(tilei),16);
		x1=y1=0;
		x2=0;y2=40;

		for(i=0;i<5*4;i++){
RETRY:
			j=nrand(5);
			k=nrand(4);
			if(tilei[k][j]==0xffff){
				tilei[k][j]=i;
			}
			else{
				goto RETRY;
			}
		}
		mk_bg(0,0xfffff);
		disp_on();
		gm_mode=GM_START;
		break;
	case GM_START:
		gm_mode=GM_GAME;
		time=20000;
		break;
	case GM_GAME:
		gm_cnt=0;
		if((trg & R_KEY)&&(x1<4*48)){
			nx=x1+48;
			ny=y1;
			gm_moving();
		}
		else if((trg & L_KEY)&&(x1>0)){
			nx=x1-48;
			ny=y1;
			gm_moving();
		}
		else if((trg & D_KEY)&&(y1<3*40)){
			nx=x1;
			ny=y1+40;
			gm_moving();
		}
		else if((trg & U_KEY)&&(y1>0)){
			nx=x1;
			ny=y1-40;
			gm_moving();
		}
		if(trg & A_BUTTON){
			nx=x2;
			ny=y2;
			ox=x1;
			oy=y1;
			mk_bg(0,0xfffff ^ ((1 << ((x1/48)+(y1/40)*5))|(1 << ((x2/48)+(y2/40)*5))));
			mk_bg(1,(1 << ((x1/48)+(y1/40)*5)));
			mk_bg(2,(1 << ((x2/48)+(y2/40)*5)));
			gm_mode=GM_CHANGING;
		}
		if(--time < 0) time=0;
		break;
	case GM_MOVING:
		if(++gm_cnt==10){
			gm_mode=GM_GAME;
			x2=ox;
			y2=oy;
			x1=nx;
			y1=ny;
		}
		else{
			x1=x1+(nx-x1)*gm_cnt/10;
			y1=y1+(ny-y1)*gm_cnt/10;
			x2=x2+(ox-x2)*gm_cnt/10;
			y2=y2+(oy-y2)*gm_cnt/10;
		}
		if(--time < 0) time=0;
		break;
	case GM_CHANGING:
		if(++gm_cnt==10){
			gm_mode=GM_GAME;
			i=tilei[y1/40][x1/48];
			tilei[y1/40][x1/48]=tilei[y2/40][x2/48];
			tilei[y2/40][x2/48]=i;
			mk_bg(0,0xfffff);
			mk_bg(1,0);
			mk_bg(2,0);
			*((vu16 *)REG_BG1HOFS)=0;
			*((vu16 *)REG_BG1VOFS)=0;
			*((vu16 *)REG_BG2HOFS)=0;
			*((vu16 *)REG_BG2VOFS)=0;
#ifdef DEBUG
			if(cont & SELECT_BUTTON){
				for(i=0;i<4;i++){
					for(j=0;j<5;j++){
						tilei[i][j]=j+i*5;
					}
				}
			}
			mk_bg(0,0xfffff);
#endif
			for(i=0;i<4;i++){
				for(j=0;j<5;j++){
					if(tilei[i][j]!=j+i*5) break;
				}
			}
			if((i==4)&&(j==5)){
				gm_mode=GM_CLEAR;
				score+=10000+time;
			}
		}
		else{
			*((vu16 *)REG_BG2HOFS)=(nx-ox)*gm_cnt/10;
			*((vu16 *)REG_BG2VOFS)=(ny-oy)*gm_cnt/10;
			*((vu16 *)REG_BG1HOFS)=(ox-nx)*gm_cnt/10;
			*((vu16 *)REG_BG1VOFS)=(oy-ny)*gm_cnt/10;
		}
		if(--time < 0) time=0;
		break;
	case GM_CLEAR:
		y1=y2=160;
		if(cnt & 0x10){
			oprintf(48,80,"%C5STAGE %d CLEARDED",stage);
		}
		if(++gm_cnt==120){
			gm_mode=GM_LOADING;
		}
		break;
	case GM_ALL_CLEAR:
		y1=y2=160;
		if(cnt & 0x10){
			oprintf(48,80,"%C2ALL STAGE CLEARD",stage);
			oprintf(75,90,"%C4PUSH START",stage);
		}
		if(++gm_cnt>=180){
			disp_off();
			gm_cnt=0;
			if((i=bmp2vram(bmp_buf))==0){
				bmp_buf=&__iwram_overlay_lma;
				i=bmp2vram(bmp_buf);
			}
			bmp_buf+=i;
			disp_on();
		}
		if(trg & START_BUTTON){
			mode=MODE_TITLE;
		}
		break;
	}
}

init_score(){
}

mode_score(){
}

extern void intr_main(void);
vu16 vsync_flag;

void AgbMain(void)
{
    s32 i,j;
    u16 m;

    DmaClear(3, 0,   VRAM,     VRAM_SIZE,            32);
    DmaClear(3, 160, OAM,      OAM_SIZE,             32);
    DmaClear(3, 0,   PLTT,     PLTT_SIZE,            32);

    DmaCopy(3, intr_main, intr_buf, sizeof(intr_buf), 32);
    *(vu32 *)INTR_VECTOR_BUF = (vu32 )intr_buf;

    DmaArrayCopy(3, font_Char, OBJ_MODE0_VRAM, 32);

	for(i=1;i<8;i++){
		for(j=0;j<16;j++){
			m=0;
			if(i & 1) m|=0x001f;
			if(i & 2) m|=0x03e0;
			if(i & 4) m|=0x7c00;
			if(j<2) m=0xffff;
			*((u16 *)OBJ_PLTT+(i-1)*16+j)=font_Palette[j] & m;
		}
	}

    *(vu16 *)REG_BG0CNT =
            BG_COLOR_256 | BG_SCREEN_SIZE_0 | BG_PRIORITY_3
            | 0 << BG_SCREEN_BASE_SHIFT | 1 << BG_CHAR_BASE_SHIFT ;
    *(vu16 *)REG_BG1CNT =
            BG_COLOR_256 | BG_SCREEN_SIZE_0 | BG_PRIORITY_2
            | 1 << BG_SCREEN_BASE_SHIFT | 1 << BG_CHAR_BASE_SHIFT ;
    *(vu16 *)REG_BG2CNT =
            BG_COLOR_256 | BG_SCREEN_SIZE_0 | BG_PRIORITY_1
            | 2 << BG_SCREEN_BASE_SHIFT | 1 << BG_CHAR_BASE_SHIFT ;

    *(vu16 *)REG_IME   = 1;                           // IME Zbg
    *(vu16 *)REG_IE    = V_BLANK_INTR_FLAG;           // VuN
    *(vu16 *)REG_STAT  = 0x0008;
    cnt=0;
    old_mode=0xffff;
    mode=MODE_TITLE;
    init_rand(0);

    while(1) {
		cnt++;
		oprn_clear();
        key_read();
        if(old_mode!=mode){
			old_mode=mode;
			switch(mode){
			case MODE_TITLE:
				init_title();
				break;
			case MODE_GAME:
				init_game();
				break;
			case MODE_SCORE:
				init_score();
				break;
			}
		}
        switch(mode){
		case MODE_TITLE:
			mode_title();
			break;
		case MODE_GAME:
			mode_game();
			break;
		case MODE_SCORE:
			mode_score();
			break;
		}
		vsync_flag=1;
		for(;;){
			if(vsync_flag==0) break;
		}
    }
}

void vsync_intr(void){
	vsync_flag=0;
}

void dummy_intr(void){
}

void key_read(void){
    u16 ReadData = (*(vu16 *)REG_KEYINPUT ^ 0x03ff);
    trg  = ReadData & (ReadData ^ cont);
    cont = ReadData;
}
