#include <varargs.h>
#include "gba.h"

#define	OPRN_START	0
#define	OPRN_NUM	64

u8  col;
u16	oprn_idx;

static s32 __udeci(u32 u,s8 *s,s32 i){
	u32 div,flg;
	div=1000000000;
	flg=0;
	for(;;){
		if(u/div){
			s[i++]='0'+(u/div)-' ';
			flg=1;
			u-=(u/div)*div;
		}
		else if(flg || (div==1)){
			s[i++]='0'-' ';
		}
		div=div/10;
		if(div==0) break;
	}
	return(i);
}

static s8 _hexchar[16]={
'0','1','2','3','4','5','6','7',
'8','9','A','B','C','D','E','F'
};

static s32 __hex(u32 u,s8 *s,s32 i){
	u32 div,flg;
	div=0x10000000;
	flg=0;
	for(;;){
		if(u/div){
			s[i++]=_hexchar[u/div]-' ';
			flg=1;
			u-=(u/div)*div;
		}
		else if(flg || (div==1)){
			s[i++]='0'-' ';
		}
		div=div/16;
		if(div==0) break;
	}
	return(i);
}

//	%d:POi
//	%u:ȂPOi
//	%x:PUi
//	%s:
//	%c:
//	\n:s

s32 oprintf(va_alist) va_dcl{
	va_list args;
	s32 i,d;
	u32 u;
	s16 x,y;
	s8 *ss;
	s8 *fmt;
	s8 s[256];

	va_start(args);
	x=va_arg(args,s32);
	y=va_arg(args,s32);
	fmt=va_arg(args,char *);
	for(i=0;;){
		if(*fmt=='%'){
			switch(fmt[1]){
			case 'd':		//	%d:POi
				fmt+=2;
				d=va_arg(args,s32);
				if(d<0){
					s[i++]='-'-' ';
					u=-d;
				}
				else{
					u=d;
				}
				i=__udeci(u,s,i);
				break;
			case 'u':		//	%u:ȂPOi
				fmt+=2;
				u=va_arg(args,u32);
				i=__udeci(u,s,i);
				break;
			case 'x':		//	%x:PUi
				fmt+=2;
				u=va_arg(args,u32);
				i=__hex(u,s,i);
				break;
			case 's':		//	%s:
				fmt+=2;
				ss=va_arg(args,s8 *);
				for(d=0;;d++){
					if(ss[d]==0) break;
					s[i++]=ss[d]-' ';
				}
				break;
			case 'c':		//	%c:
				fmt+=2;
				d=va_arg(args,s32);
				s[i++]=d-' ';
				break;
			case 'C':		//Color
				col=fmt[2]-'0';
				fmt+=3;
				break;
			default:
				s[i++]=*fmt-' ';
				fmt++;
				break;
			}
		}
		else{
			if((i>240)||(*fmt==0)){
				s[i++]=0;
				break;
			}
			s[i++]=*fmt-' ';
			fmt++;
		}
	}
	va_end(args);
	for(d=0;d<i-1;d++){
		*((u16 *)0x7000000+4*oprn_idx)=y & 0xff;
		*((u16 *)0x7000002+4*oprn_idx)=x & 0xff;
		*((u16 *)0x7000004+4*oprn_idx)=(col<<12)+s[d];
		oprn_idx++;
		x+=9;
	}
	return(0);
}

void oprn_clear(){
	s32 i;
	col=0;
	oprn_idx=0;
	for(i=OPRN_START;i<OPRN_START+OPRN_NUM;i++){
		*((u16 *)0x7000000+4*i)=160;
	}
}
